#!/usr/bin/perl;

#===============================================================================
#  REVISION:      $Id:$
#  AUTHORS:       dimio (www.dimio.org, dimio@dimio.org)
#  CREATED:       27-12-2009
#  DESCRIPTION:   Скрипт для автоматического создания флотов из указанных юнитов для игры Divide&Conquer
#===============================================================================
require v5.8.8;
use warnings;
use strict;
use Encode 'decode';
use LWP::UserAgent;
use HTTP::Cookies;
use Compress::Zlib;
use POSIX;
# use Data::Dumper;
use utf8;
require encoding;
import encoding  ('utf8', 'STDOUT' => &SetEncoding);
$| = 1;
our $VERSION = 2.0;
# ПОЛЬЗОВАТЕЛЬСКИЕ ПЕРЕМЕННЫЕ
my $login = 'test_account' || shift;
my $password = 'test_account' || shift;
my $base_url = 'http://www.the-game.ru'; # этот параметр без нужды менять не стоит
# my $logfile = 'dcfleets_log.log';
######## ОСНОВНАЯ ЧАСТЬ ########
if (defined($ARGV[0]) && $ARGV[0] =~ /^-{0,2}(:?h|help)$/i) {
   &Usage;
   exit 0;
}

my $browser = &UAInit;
my @fleets_id;
my @units_id;
# open (LOG,'>',$logfile);

my ($user_name,$acc_id,$source) = FirstAuth ($browser, \$base_url, $login, $password);
   print "\nВыполнен вход на сервер с именем $user_name (ID= $acc_id)\n";

while (1) {
   print "\n".'Введите координаты планеты-цели X:Y или "exit" для выхода: ';
   my $coord = <STDIN>;
   chomp $coord;
      last if $coord =~ /^e|exit$/i;
   $coord =~ s/[;,.-]/:/g;

   my $planet_harrison_fleets = ParseHarrison ($browser,\$base_url,$coord,0,0,0,0);
# print LOG Dumper($planet_harrison_fleets);  LogOff ($browser,\$base_url,$acc_id); exit;
   if ($planet_harrison_fleets != 0) {

      print 'В гарнизоне планеты '.$coord.' найдены юниты:',"\n";
      printf ("%-5.5s %-16.20s %-6.6s\n",'ID','Название','Кол-во');

      foreach my $unit (keys %{ $planet_harrison_fleets }) { # вывод гарнизона планеты на печать
         printf ("%-5.5u %-16.20s %-6.6s\n",$unit,${$planet_harrison_fleets}{$unit}[0],${$planet_harrison_fleets}{$unit}[1]);
      } # конец печати гарнизона

      print 'Введите название флота для создания флотов на планете: ';
         my $fleet_name = <STDIN>;
         chomp $fleet_name;
      print 'Введите ID юнита, который будет перемещён в новый флот "'.$fleet_name.'": ';
         my $moving_unit_id = <STDIN>;
      print 'Укажите кол-во юнитов данного типа, из которых надо создать флоты (если пусто - использовать все): ';
         my $moving_unit_count = <STDIN>;
      print 'Сколько юнитов перемещать в один флот (один, если пусто): ';
         my $unit_perl_fleet = <STDIN>;
      chomp ($moving_unit_id, $moving_unit_count, $unit_perl_fleet);
      chomp ($moving_unit_id, $moving_unit_count);
      $moving_unit_count = ${$planet_harrison_fleets}{$moving_unit_id}[1] if !$moving_unit_count;
      #$unit_perl_fleet = 1 if !$unit_perl_fleet;
      my $moving_unit_name = ${$planet_harrison_fleets}{$moving_unit_id}[0];

      my $total_fleets = ceil ($moving_unit_count/$unit_perl_fleet);

      print 'Будет создано флотов: '.$total_fleets.', ждите ';

      for (1..$total_fleets) {
         my $new_fleet_id = CreateFleet ($browser,\$base_url,$coord,$fleet_name,\@fleets_id);

         for (1..$unit_perl_fleet) {
            MoveUnitToFleet ($browser,\$base_url,$coord,$moving_unit_id,$new_fleet_id);
            $moving_unit_id = ParseHarrison ($browser,\$base_url,$coord,$moving_unit_name,0,0,\@units_id);
         }
         sleep (int(rand(2))+2);
         print '.';
      }
      print "\n";
   }
   else {
      print 'Не могу получить фрейм гарнизона планеты '.$coord.'. Конец работы.',"\n";
   }
}

print 'Отключаюсь от сервера: '. LogOff ($browser,\$base_url,$acc_id),"\n";
# close (LOG);
exit 0;
######## ФУНКЦИИ ########
sub ParseHarrison {
   my ($browser,$base_url,$coord,$unit_name,$fleet_name,$fleets_id,$units_id) = @_;

   my $response = $browser->get($$base_url.'/frames/planet_fleets/on/planet/?planetid='.$coord);
   my $source = decode ( 'utf8', Compress::Zlib::memGunzip (\($response->content)[0]) );

   if ($source =~ m#<div(.+?)</div>#is) { # разделение на гарнизон и флоты
      my $planet_harrison = $1;
      my $planet_fleets = $';

      if (!$unit_name && !$fleet_name && !$fleets_id) { # усли функция не получала имени юнита или флота - надо разбирать весь гарнизон
         my %planet_harrison;

         while ($planet_harrison =~ m#HelpWnd\('/frames/unit_stats/on/(\d{5})'\).+?building_name.+?>(.+?)\s<.+?x?(\d{0,2})\)#ig) { # парсинг гарнизона планеты
            my $count = $3 || 1; # если число юнитов прямо не указано в коде - принять его равным единице
            push ( @{$planet_harrison{$1}}, $2, $count ); # хэш { ID => [назв_юнита, кол-во_юнитов] }
         } # конец парсинга гарнизона
         return \%planet_harrison; # если ID конкретного юнита не нужно - выходим из функции
      } # конец условия разбора всего гарнизона

      elsif ($fleet_name !~ /^0$/ && $fleets_id !~ /^0$/) { # если в функцию передано имя флота - нужно вернуть его ID
         while ($planet_fleets  =~ m#<option value="(\d{5})">$fleet_name</option>#ig) { # обходим список флотов над планетой
            my $tmp = $1; # и получаем ID флота с нужным нам именем
            my $flag = 0;
            foreach my $el ( @{ $fleets_id } ) { # проверяем, не обрабатывался ли раньше флот с таким ID
               $flag = 1 if $tmp == $el # надо почитать, нельзя ли как-то через grep эту проверку упростить
            }
            if ($flag == 0) {
               push ( @{ $fleets_id }, $tmp);
               return $tmp;
            }
        } # конец обхода списка флотов
      } # конец условия возврата ID флота

      elsif ($unit_name !~ /^0$/ && $units_id !~ /^0$/) { # если в функцию передано имя юнита - нужно вернуть его ID
         while ($planet_harrison =~ m#HelpWnd\('/frames/unit_stats/on/(\d{5})'\).+?building_name.+?>$unit_name\s<#ig) {

            my $tmp = $1;
            my $flag = 0;
            foreach my $el ( @{ $units_id } ) { # проверяем, не обрабатывался ли раньше флот с таким ID
               $flag = 1 if $tmp == $el # надо почитать, нельзя ли как-то через grep эту проверку упростить
            }
            if ($flag == 0) {
               push ( @{ $units_id }, $tmp);
               return $tmp;
            }
        }
      } # конец условия возврата ID юнита
   } # конец разделения на гарнизон и флоты

   else { # если не удалось получить фрейм гарнизона - вернём ошибку
      return 0;
   }
}

sub MoveUnitToFleet {
   my ($browser, $base_url, $coord, $unit_id, $fleet_id) = @_;
   my $uri = $$base_url.'/planet/?planetid='.$coord.'&action=move_unit_to_fleet&fleet_id='.$fleet_id.'&unit_id='.$unit_id;
   my $response = $browser->get($uri);
      print "Error: $response->status_line\n" unless $response->is_success;
      # return 1;
}

sub CreateFleet {
   my ($browser,$base_url,$coord,$fleet_name,$fleets_id) = @_;

   my $response = $browser->get($$base_url.'/frames/planet_fleets/on/planet/?planetid='.$coord.'&action=create_new_fleet&new_fleet_name='.$fleet_name);
      print "Error: $response->status_line\n" unless $response->is_success;
   return my $new_fleet_id = ParseHarrison ($browser,$base_url,$coord,0,$fleet_name,$fleets_id,0);
}

sub FirstAuth {
   my ($browser, $base_url, $login, $pass) = @_;
#  next if length($pass) < 8; # переходим к след. акку, если логин и пароль распарсились криво - косяк разбора входного файла, см. ф-ю ReadAccData
   my $response = $browser->post($$base_url. '/overview/',
      [
      'action' => 'login',
      'login'  => $login,
      'pwd'    => $pass,
      ]);
      do {print "Connection error: ".$response->status_line,"\n"; next;} unless $response->is_success;
   my $source = Compress::Zlib::memGunzip(\($response->content)[0]);
   my $user_name = $1 if $source =~ /.+?::.+?::\s(.*)<\/title>/;
   my $acc_id = $1 if $source =~ /var PlayerId=(\d{1,7});/;

return ($user_name, $acc_id, $source);
}

sub LogOff { # отключаемся от сервера
# Производит отключение от сервера the-game.
   my ($browser, $base_url, $acc_id) = @_;
   my $response = $browser->get($$base_url.'/logoff/'.$acc_id);

return $response->status_line;
}


sub UAInit {
   my $cookies=HTTP::Cookies->new('file'=>'./cookies.lwp','autosave'=>0);
   my $browser=LWP::UserAgent->new('agent' => 'Mozilla/5.0 (Windows; U; Windows NT 5.1; ru; rv:1.9.0.11) Gecko/2009060215 Firefox/3.0.11)',
                                 'cookie_jar' => $cookies,
                                 'requests_redirectable' => ['GET', 'POST']);
   $browser->default_header('Accept' => 'text/html, application/xml;q=0.9, application/xhtml+xml, image/png, image/jpeg, image/gif, image/x-xbitmap, */*;q=0.1',
						'Accept-Charset' => 'utf-8; *;q=0.1',
						'Accept-Language' => 'ru,en-us;q=0.7,en;q=0.3',
						'Accept-Encoding' => 'deflate, gzip, x-gzip, identity, *;q=0',
						);
return ($browser);
}

sub Usage {
   print
         'Скрипт для раскидывания юнитов по флотам, версия '.$VERSION."\n".
         'На указанной планете из юнитов указанного типа создаёт флоты
          и помещает в каждый флот по одному юниту. Задумывался для
          раскидывания зондов или подобной мелочи по флотам.'."\n".
         'Формат запуска: $ dc_fleet <логин> <пароль>'."\n".
         'Также эти данные могут быть указаны непосредственно внутри скрипта,
          там же настраивается кодировка вывода'
   ,"\n";
}

sub SetEncoding {
	if ($^O =~ /^MSWin\d{2}$/i) {
		return 'cp866';
	}
	elsif ($^O =~ /^cygwin$/i) {
		return 'cp1251';
	}
	elsif ($^O =~ /^linux$/i) {
		return 'utf8';
	}
    else {
      print "Can't detect and set terminal encoding\n";
      exit 0;
    }
}
